
#include <iomanip.h>
#include <math.h>



// 
void ArrayToArray (double x[],double y[],int n)
//
//     .
// :
//   -  - ,
//  y -  - ,
//  n -   .
//  :
//  .
//
{
 for (register int i = 0; i < n; i++)
   y[i] = x[i];
}

///////////////////////////////////////
void FillUp (double a[],int n,double p)
//
//     .
// :
//  a -   n,
//  p - .
//  :
//  .
//
{
 for (register int i = 0; i < n; i++)
   a[i] = p;
}
/////////////////////////////////////////////
void FillUp (int a[],int n,int p)
//
//      .
// :
//  a -   n,
//  p - .
//  :
//  .
//
{
 for (register int i = 0; i < n; i++)
   a[i] = p;
}

//////////////////////////////////////////////////////////
// 
int Gauss (double b[],double a[],int row,int column,double eps)
//
//      
//       .
// :
//       b -     ,
//           ,   - 
//              ,
//       a -    row, ,
//     row -   -    a  b 
//             a,
//  column -    b,
//     eps -     .
//  :
//   0    ,
//  -2   .
//
{
 int i,j,k,    // 
     js,ji,ij,
     im,mi,mj,
     is,       //     
     ik,       //   
     in,       //    
     jn;       //    

 double guide, //    
        save;  // 

 ////////////////////////////////////////////
 //   -  
 for (k = 0, ik = -row; k < row; k++)
   {
    ik += row;
    is = ik + k;

    //////////////////////////
    //   
    for (i = k, ij = is, in = k, jn = k, guide = a[is];
         i < row; i++)
      for (j = k, im = ij++; j < row; j++)
        {
         if (fabs (a[im]) > fabs (guide))
          {
           guide = a[im];
in = i;
           jn = j;
          }
         im += row;
        }

    /////////////////////////
    //   
    if (fabs (guide) < eps)
      return -2;

    /////////////////////
    //  
    for (i = k, im = is, ij = ik + in; i < row; i++)
      {
       save = a[ij];
       a[ij] = a[im];
       a[im] = save / guide;
       ij += row;
       im += row;
      }
    for (i = 0, ij = in, im = k; i < column; i++)
      {
       save = b[ij];
       b[ij] = b[im];
       b[im] = save / guide;
       ij += row;
       im += row;
      }

    ////////////////////////
    //  
    for (i = 0, im = ik - 1, ij = row * jn - 1; i < row; i++)
      {
       save = a[++ij];
       a[ij] = a[++im];
       a[im] = save;
      }
    //////////////////////////////////////////
    //    
    ji = k + 1;
    for (i = ji, im = is, mi = is + row; i < row; i++)
      {
       for (j = ji, mj = mi, ij = ++im + row, save = a[im];
            j < row; j++)
         {
          a[ij] = a[ij] - a[mj] * save;
          mj += row;
          ij += row;
         }
       for (j = 0, ij = i, mj = k; j < column; j++)
         {
          b[ij] = b[ij] - b[mj] * save;
          ij += row;
          mj += row;
         }
      }

    ////////////////////////////////////////////////////////
    //      
    //     
    if (k == 0)
for (i = 0; i < row; i++)
        a[i] = (double) i;  //   
    save = a[jn];           //   
    a[jn] = a[k];
    a[k] = save;
   }
 
  /////////////////////////////////////////
 //   -  
 for (i = row - 1, im = row * row - 1; i > 0; i--)
   for (js = 0, --im, in = i - 1, mi = 0; js < column; js++)
     {
      for (j = row - 1, ij = im, save = 0; j >= i; j--)
        {
         save += b[j + mi] * a[ij];
         ij -= row;
        }
      ji = in + mi;
      b[ji] = b[ji] - save;
      mi += row;
     }

 /////////////////////////////////
 //   
 for (i = 0, j = 0; i < row; i++)
   {
    in = (int) (a[j]);
    if (in == j)
      j++;        //      
    else
      {
       for (js = 0, ij = in, ji = j; js < column; js++)
         {
          save = b[ij];
          b[ij] = b[ji];
          b[ji] = save;
          ij += row;
          ji += row;
         }
       save = a[in];
       a[in] = a[j];
       a[j] = save;
      }
   }
 return 0;
}




int Polynomial (double y[],double x[],int u,int m,int n,double c[])
//
//    .
// :
//   y -    n,
//   x -    n,
//   u -   ,
//   m -  ,
//   c -     m - u + 1.
//  :
//   0    ,
//  -1   ,
//  -2   .
// : m <= n.
//
{
 register int i,j,k,l; // 

 int Code = 0,         //  
     mu = m - u + 1;   //  

 double *z,            //   
        *b;            //   

 if ((z = new double[mu * mu]) == 0)
   return -1;
 if ((b = new double[mu]) == 0)
   {
    delete [] z;
    return -1;
   }

 //////////////////////////////////////////////////////
 //     
 FillUp (z,mu * mu,0);
 FillUp (b,mu,0);

 ////////////////////////////////////////
 //    
 for (k = u; k <= m; k++)
   {
    for (i = 0; i < n; i++)
      {
       for (j = u, l = k - u; j <= m; j++)
         {
          z[l] += pow (x[i],j + k);
          l += m - u + 1;
         }
       b[k - u] += y[i] * pow (x[i],k);
      }
   }

 /////////////////////////////////////
 //    
 if (!(Code = Gauss (b,z,mu,1,0.000001)))
   ArrayToArray (b,c,mu);

 delete [] z; delete [] b;

 return Code;
}